//----------------------------------------------------------------------//
// NyanFi																//
//  摜r[Xbh												//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <algorithm>
#include <RegularExpressions.hpp>
#include "usr_wic.h"
#include "usr_exif.h"
#include "UserFunc.h"
#include "Global.h"
#include "HistFrm.h"
#include "MainFrm.h"
#include "PrnImgDlg.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
//Xbh̏
//---------------------------------------------------------------------------
__fastcall TImgViewThread::TImgViewThread(bool CreateSuspended) : TThread(CreateSuspended)
{
	Priority = tpLower;
	FreeOnTerminate = true;

	Rotation   = 0;
	ExifOri	   = 0;
	ZoomRatio  = 100;
	ZoomRatioF = 1.0;
	Fitted	   = true;
	ShowGrid   = false;
	GrayScaled = false;

	ImgBuff    = new Graphics::TBitmap();
	ViewBuff   = new Graphics::TBitmap();
	ChgBuff    = new Graphics::TBitmap();
	MetaBuff   = new TMetafile();

	Img_f_size	= 0;
	Img_f_time	= 0;
	ImgIsWmf	= false;

	TaskBusy	= false;
	ReqRedraw	= false;
	ReqReload	= false;
	ReqChange	= false;
	ReqClear	= false;
	ReqVideo	= false;

	UseViewBuff = false;
	MsgIsErr	= false;
}

//---------------------------------------------------------------------------
//摜NA(Synchronize ŌĂяo)
//---------------------------------------------------------------------------
void __fastcall TImgViewThread::ClearImage()
{
	TImage *v_img = NULL;
	if (NyanFiForm->ImgViewPanel->Visible)
		v_img = NyanFiForm->ViewerImage;
	else if (NyanFiForm->PreviewPanel->Visible) {
		v_img = NyanFiForm->PreviewImage;
		NyanFiForm->PreviewSttLabel->Visible = false;
		NyanFiForm->PreviewSttLabel->Caption = EmptyStr;
		NyanFiForm->PreviewPanel->Color 	 = col_bgImage;
	}

	if (v_img) {
		v_img->Picture->Bitmap->SetSize(v_img->ClientWidth, v_img->ClientHeight);
		TCanvas *cv = v_img->Picture->Bitmap->Canvas;
		cv->Lock();
		{
			cv->Brush->Color = col_bgImage;
			cv->FillRect(v_img->ClientRect);
		}
		cv->Unlock();
	}

	Img_f_name = EmptyStr;  Img_f_size = 0;  Img_f_time = 0;  ImgIsWmf = false;

	NyanFiForm->ImgInfListBox->Clear();
	if (HistForm->Visible) HistForm->DrawHistogram();
}

//---------------------------------------------------------------------------
//摜\ (Synchronize ŌĂяo)
//---------------------------------------------------------------------------
void __fastcall TImgViewThread::DrawImage()
{
	if (ImgIsWmf && MetaBuff->Empty) return;
	if (!ImgIsWmf && ImgBuff->Empty) return;

	TImage *v_img	= NULL;
	TPanel *v_panel = NULL;

	//C[WrA[
	if (NyanFiForm->ImgViewPanel->Visible) {
		v_img	= NyanFiForm->ViewerImage;
		v_panel = NyanFiForm->ImgScrollPanel;
	}
	//vr[
	else if (NyanFiForm->PreviewPanel->Visible) {
		v_img	= NyanFiForm->PreviewImage;
		v_img->Transparent = false;
		v_panel = NyanFiForm->PreviewPanel;
	}

	if (!v_img) return;

	bool is_viewer = USAME_TS(v_img->Name, "ViewerImage");

	//]
	if (!ImgBuff->Empty && Rotation>0) {
		WIC_rotate_image(ImgBuff, Rotation);
		Rotation = 0;
	}

	if (!ReqRedraw || ReqReload) {
		ViewBuff->Handle = NULL;

		int iw = ImgIsWmf? MetaBuff->Width  : ImgBuff->Width;
		int ih = ImgIsWmf? MetaBuff->Height : ImgBuff->Height;
		if (iw==0 || ih==0) return;

		double r = 1.0;
		//vr[܂̓tBbg\
		if (!is_viewer || Fitted) {
			r = get_ZoomRatio(v_panel->ClientWidth, v_panel->ClientHeight, iw, ih,
				is_viewer? ImgFrameMargin : 0,
				Fitted? (std::max(ImgFitMaxZoom, 100)/100.0) : 1.0);
			if (is_viewer) ZoomRatio = r * 100;
		}
		//Y[
		else if (is_viewer && ZoomRatio!=100)
			r = ZoomRatio / 100.0;

		ZoomRatioF = r;

		//^t@C
		if (ImgIsWmf) {
			if (r!=1.0) {
				iw *= r;  ih *= r;
			}
			ViewBuff->SetSize(iw, ih);
			TRect rc = Rect(0, 0, iw, ih);
			TCanvas *cv = ViewBuff->Canvas;
			cv->Lock();
			{
				cv->Brush->Color = col_bgWMF;
				cv->FillRect(rc);
				cv->StretchDraw(rc, MetaBuff);
			}
			cv->Unlock();
			//]E]
			if (Rotation>0) {
				Img_rot_str.cat_sprintf(_T("%u"), Rotation);
				Rotation = 0;
			}
			for (int i=1; i<=Img_rot_str.Length(); i++)
				WIC_rotate_image(ViewBuff, Img_rot_str.SubString(i, 1).ToIntDef(0));
			//璷ȏ폜
			if (Img_rot_str.Length()>1)
				Img_rot_str = replace_regex(Img_rot_str, _T("13|31|44|55|1111|3333"), null_TCHAR);
		}
		//摜t@C
		else {
			if (r!=1.0) {
				//gEk
				if (WicScaleOpt>=0 && WicScaleOpt<=3)
					WIC_resize_image(ImgBuff, ViewBuff, r, 0, 0, WicScaleOpt);
				else {
					iw *= r;  ih *= r;
					ViewBuff->SetSize(iw, ih);
					ViewBuff->PixelFormat = pf24bit;
					ViewBuff->Canvas->StretchDraw(Rect(0, 0, iw, ih), ImgBuff);
				}
			}
			else
				//{
				ViewBuff->Assign(ImgBuff);
		}

		//O[XP[
		if (GrayScaled) WIC_grayscale_image(ViewBuff);

		if (is_viewer) {
			UnicodeString sttstr; sttstr.sprintf(_T("%3u%"), ZoomRatio);
			if (NyanFiForm->ImgSttHeader->Visible) NyanFiForm->ImgSttHeader->Panels->Items[3]->Text = sttstr;
			if (NyanFiForm->ImgInfBar->Visible)    NyanFiForm->ImgInfBar->Panels->Items[1]->Text 	= sttstr;
		}
	}

	//`
	v_img->Center = true;
	//C[WrA[
	if (is_viewer) {
		TControlScrollBar *hbar = NyanFiForm->ImgScrollBox->HorzScrollBar;
		TControlScrollBar *vbar = NyanFiForm->ImgScrollBox->VertScrollBar;

		if (ViewBuff->Width>v_panel->ClientWidth || ViewBuff->Height>v_panel->ClientHeight) {
			//XN[o[ݒ
			hbar->Range = ViewBuff->Width;
			vbar->Range = ViewBuff->Height;
			//Z^[Ɉړ
			hbar->Position = (hbar->Range - v_panel->ClientWidth)/2;
			vbar->Position = (vbar->Range - v_panel->ClientHeight)/2;
		}
		else {
			hbar->Range = v_panel->ClientWidth;
			vbar->Range = v_panel->ClientHeight;
		}

		NyanFiForm->ImgScrollBox->Color = ImgIsWmf? col_bgWMF : col_bgImage;
		v_img->Picture->Bitmap->Assign(ViewBuff);

		//Obh
		if (is_viewer && ShowGrid) draw_ImgGrid(v_img->Picture->Bitmap->Canvas, ViewBuff, ImgIsWmf);

		NyanFiForm->SetSttBarInf();

		//qXgO
		if (HistForm->Visible) HistForm->DrawHistogram(ImgBuff);

		//ݒ
		if (PrintImgDlg && PrintImgDlg->Visible) PrintImgDlg->DrawImage();
	}
	//vr[\
	else {
		NyanFiForm->PreviewSttLabel->Visible = false;
		NyanFiForm->PreviewSttLabel->Caption = EmptyStr;
		NyanFiForm->PreviewPanel->Color = ImgIsWmf? col_bgWMF : col_bgImage;
		v_img->Align   = alClient;
		v_img->Stretch = false;
		v_img->Picture->Bitmap->Assign(ViewBuff);
	}

	NyanFiForm->ImgBuff->Assign(ImgBuff);
	NyanFiForm->UpdateLoupe();
}

//---------------------------------------------------------------------------
//C[Wvr[ ViewBuff \ (Synchronize ŌĂяo)
//---------------------------------------------------------------------------
void __fastcall TImgViewThread::DrawViewBuff()
{
	if (NyanFiForm->PreviewPanel->Visible) {
		NyanFiForm->PreviewSttLabel->Visible = false;
		NyanFiForm->PreviewSttLabel->Caption = EmptyStr;
		NyanFiForm->PreviewPanel->Color 	 = col_bgImage;

		TImage *v_img = NyanFiForm->PreviewImage;
		v_img->Transparent = false;
		v_img->Align	   = alClient;
		v_img->Stretch	   = false;
		v_img->Center	   = false;
		v_img->Picture->Bitmap->Assign(ViewBuff);
	}

	NyanFiForm->ImgBuff->Assign(ImgBuff);
}

//---------------------------------------------------------------------------
//bZ[W\ (Synchronize ŌĂяo)
//---------------------------------------------------------------------------
void __fastcall TImgViewThread::DrawMessage()
{
	if (MsgStr.IsEmpty()) {
		if (NyanFiForm->ImgViewPanel->Visible) {
			if (ShowSttBar)
				NyanFiForm->StatusBar1->Panels->Items[0]->Text = EmptyStr;
			else
				NyanFiForm->ShowMessageHint();
		}
		return;
	}

	//C[WrA[
	if (NyanFiForm->ImgViewPanel->Visible) {
		if (ShowSttBar) {
			NyanFiForm->StatusBar1->Panels->Items[0]->Text = MsgStr;
			NyanFiForm->StatusBar1->Repaint();
			if (MsgIsErr) beep_Warn();
		}
		else if (ShowMsgHint && MsgIsErr) NyanFiForm->ShowMessageHint(MsgStr, col_bgWarn, true);
	}
	//vr[
	else if (NyanFiForm->PreviewPanel->Visible) {
		TLabel *lp = NyanFiForm->PreviewSttLabel;
		lp->Caption 	= MsgStr;
		lp->Font->Color = MsgIsErr? col_Error : col_Teal;
		lp->Top 		= NyanFiForm->PreviewPanel->ClientHeight - lp->Height - 4;
		lp->Left		= 8;
		lp->Visible 	= true;
	}
}

//---------------------------------------------------------------------------
void __fastcall TImgViewThread::Execute()
{
	::CoInitialize(NULL);

	while (!Terminated) {
		//`v
		if (ReqRedraw || ReqReload || ReqChange) {
			if (ReqChange) {
				//rbg}bv(ImgBuff)̕ύX
				FileName   = FileName2 = EmptyStr;
				Img_f_name = EmptyStr;  Img_f_size = 0;  Img_f_time = 0;  ImgIsWmf = false;
				ImgBuff->Handle = ChgBuff->ReleaseHandle();
				ReqReload = true;
			}
			Synchronize(&DrawImage);
			ReqRedraw = false;
			ReqReload = false;
			ReqChange = false;
		}
		//NAv
		else if (ReqClear) {
			Synchronize(&ClearImage);
			ImgBuff->Handle  = NULL;
			ViewBuff->Handle = NULL;
			ReqClear = false;
		}
		//t@Cǂݍ
		else if (!FileName.IsEmpty()) {
			TaskBusy = true;
			try {
				if (!file_exists(FileName)) throw Exception(EmptyStr);
				UnicodeString fnam = FileName;
				UnicodeString fext = ExtractFileExt(fnam);
				__int64	  f_size = get_file_size(fnam);
				TDateTime f_time = get_file_age(fnam);
				bool is_prv_buf = false;

				//ACR/tHg̃vr[
				if (UseViewBuff) {
					UseViewBuff = false;
					is_prv_buf 	= true;
					FileName	= EmptyStr;
					Img_f_name = fnam; Img_f_size = f_size; Img_f_time = f_time;
					ImgIsWmf = false;
					ImgBuff->Handle = NULL;

					std::unique_ptr<Graphics::TBitmap> bg_bmp(new Graphics::TBitmap());
					bg_bmp->SetSize(ViewBuff->Width, ViewBuff->Height);
					TCanvas *cv = bg_bmp->Canvas;
					cv->Lock();
					try {
						cv->Font->Assign(FileInfFont);
						cv->Font->Size	= 9;
						cv->Font->Color = SelectWorB(col_bgImage);
						int fh = cv->TextHeight("Q") + 2;

						//wi
						cv->Brush->Color = col_bgImage;
						cv->FillRect(Rect(0, 0, bg_bmp->Width, bg_bmp->Height));

						//tHg
						if (test_FontExt(fext)) {
							UnicodeString fnt_name = get_FontName(Img_f_name);
							if (!fnt_name.IsEmpty()) {
								//tHg
								cv->TextOut(2, 2, fnt_name);

								bool tmp_flag = false;
								if (Screen->Fonts->IndexOf(fnt_name)==-1)
									tmp_flag = (::AddFontResourceEx(fnam.c_str(), FR_PRIVATE, NULL)>0);

								//Zbg
								BYTE ch_set = DEFAULT_CHARSET;
								if (!tmp_flag) {
									DWORD dwSize = 0;
									if (lpGetFontResourceInfo && lpGetFontResourceInfo(fnam.c_str(), &dwSize, NULL, 2)) {
										int n = dwSize/sizeof(LOGFONT);
										if (n>0) {
											std::unique_ptr<LOGFONT[]> lfs(new LOGFONT[n]);
											if (lpGetFontResourceInfo(fnam.c_str(), &dwSize, lfs.get(), 2))
												ch_set = lfs[0].lfCharSet;
										}
									}
								}

								//Tv\
								std::unique_ptr<TFont> tmp_font(new TFont());
								tmp_font->Name	  = fnt_name;
								tmp_font->Charset = ch_set;
								tmp_font->Size	  = 20;
								tmp_font->Color   = cv->Font->Color;
								cv->Font->Assign(tmp_font.get());
								TRect rc = Rect(0, 0, bg_bmp->Width, bg_bmp->Height);
								rc.Left = 2; rc.Top = 4 + fh;
								::DrawText(cv->Handle,
									_T("0123456789(!?)+-\r\nABCDEFGabcdefg\r\nACEGI\r\ntďH~ԒL"),
									-1, &rc, DT_LEFT);

								if (tmp_flag) ::RemoveFontResourceEx(fnam.c_str(), FR_PRIVATE, NULL);
							}
						}
						//ACR
						else {
							int x = 2, y = 2, h = 0;

							if (!test_FontExt(fext)) {
								int size_lst[5] = {128, 64, 48, 32, 16};
								int top_i = ends_PathDlmtr(Img_f_name)? 1: test_FileExt(fext, FEXT_ICONVIEW)? 0 : 3;
								for (int i=top_i; i<5; i++) {
									int size = size_lst[i];
									HICON hIcon = usr_SH->get_Icon(Img_f_name, size);
									if (hIcon && size==size_lst[i]) {
										cv->TextOut(x + 2, y, size);
										::DrawIconEx(cv->Handle, x, y + fh, hIcon, size, size, 0, NULL, DI_NORMAL);
										::DestroyIcon(hIcon);
										if (size+fh > h) h = size + fh;
										if (size==64 && x>128) y += (68 + fh); else x += size + 8;
									}
								}
							}

							//oACR
							if (test_FileExt(fext, FEXT_ICONVIEW)) {
								int ixn = (int)::ExtractIcon(HInstance, Img_f_name.c_str(), -1);
								if (ixn>1) {
									x = 2;  if (h>0) y = h + 12;
									for (int i=0; i<ixn; i++) {
										HICON hIcon = ::ExtractIcon(HInstance, fnam.c_str(), i);
										if (!hIcon) continue;
										::DrawIconEx(cv->Handle, x, y, hIcon, 32, 32, 0, NULL, DI_NORMAL);
										::DestroyIcon(hIcon);
										if ((x + 2*32) > bg_bmp->Width) {
											x = 2;  y += 34;
										}
										else x += 34;
									}
								}
							}
						}

						ViewBuff->Assign(bg_bmp.get());
					}
					catch (...) {
						ViewBuff->Handle = NULL;
					}
					cv->Unlock();
				}
				//̑̃t@C
				else if (Img_f_name!=fnam || Img_f_size!=f_size || Img_f_time!=f_time) {
					Img_f_name = fnam; Img_f_size = f_size; Img_f_time = f_time;
					ImgIsWmf = test_MetaExt(fext);
					ImgBuff->Handle  = NULL;
					ViewBuff->Handle = NULL;

					MsgStr.USET_T("Ǎ..."); MsgIsErr = false;
					Synchronize(&DrawMessage);

					//
					if (ReqVideo || test_FileExt(fext, FEXT_VIDEO)) {
						ReqVideo = false;
						if (!usr_SH->get_Thumbnail(Img_f_name, ImgBuff, 2048)) TextAbort(_T("TlC擾ł܂"));
					}
					//^t@C
					else if (ImgIsWmf) {
						MetaBuff->LoadFromFile(Img_f_name);
						Img_rot_str = EmptyStr;
					}
					//MP3
					else if (test_Mp3Ext(fext)) {
						if (!ID3_GetImage(Img_f_name, ImgBuff)) ReqClear = true;
					}
					//FLAC
					else if (test_FlacExt(fext)) {
						if (!FLAC_GetImage(Img_f_name, ImgBuff)) ReqClear = true;
					}
					//fBNg̓ACR
					else if (ends_PathDlmtr(Img_f_name) &&  ShowDirJumboIco) {
						UnicodeString dnam = ExcludeTrailingPathDelimiter(Img_f_name);
						int size = 256;
						std::unique_ptr<Graphics::TBitmap> bg_bmp(new Graphics::TBitmap());
						bg_bmp->SetSize(size, size);
						TCanvas *cv = bg_bmp->Canvas;
						cv->Lock();
						{
							cv->Brush->Color = scl_Window;
							cv->FillRect(Rect(0, 0, size, size));
							//TlC
							std::unique_ptr<Graphics::TBitmap> bmp(new Graphics::TBitmap());
							if (usr_SH->get_Thumbnail(dnam, bmp.get(), size)) {
								bmp->AlphaFormat = afDefined;
								cv->Draw(0, 0, bmp.get());
							}
							//ACR
							else {
								HICON hIcon = usr_SH->get_Icon(dnam, size);
								if (hIcon) {
									::DrawIconEx(cv->Handle, 0, 0, hIcon, size, size, 0, NULL, DI_NORMAL);
									::DestroyIcon(hIcon);
								}
							}
							ImgBuff->Assign(bg_bmp.get());
						}
						cv->Unlock();
						Rotation = 0;
					}
					//ZIP
					else if (test_FileExt(fext, FEXT_ZIPIMG)) {
						//A[JCủ摜
						int res = 0;
						UnicodeString tmp_name = ExtractInZipImg(Img_f_name);
						if (!tmp_name.IsEmpty()) {
							res = load_ImageFile(tmp_name, ImgBuff, WICIMG_PREVIEW, col_bgImage);
							DeleteFile(tmp_name);
						}
						if (res==0) UserAbort(USTR_FaildLoad);
						Rotation = 0;
					}
					//摜
					else if (test_FileExt(fext, FEXT_META FEXT_WICSTD + WicFextStr) || SPI->TestFExt(fext))	{
						int res = load_ImageFile(Img_f_name, ImgBuff, WICIMG_PREVIEW, col_bgImage);
						if (res==0) UserAbort(USTR_FaildLoad);
						//J[h
						if (DoublePage) {
							if (!FileName2.IsEmpty()) {
								std::unique_ptr<Graphics::TBitmap> i2buf(new Graphics::TBitmap());
								if (load_ImageFile(FileName2, i2buf.get(), WICIMG_PREVIEW, col_bgImage)==0) UserAbort(USTR_FaildLoad);
								int i_h1 = ImgBuff->Height;
								int i_h2 = i2buf->Height;
								//JԊǔvZ
								int w_dp = 0;
								if (ImgDblMargin>0) {
									int vw = NyanFiForm->ImgScrollPanel->ClientWidth - ImgFrameMargin*2 - ImgDblMargin;
									int vh = NyanFiForm->ImgScrollPanel->ClientHeight - ImgFrameMargin*2;
									int ih = std::max(i_h1, i_h2);
									int iw = ImgBuff->Width + i2buf->Width;
									bool v_is_v = (vh>vw);
									bool i_is_v = (ih>iw);
									float r;
									if ((v_is_v && i_is_v) || (!v_is_v && !i_is_v))
										r = std::max(std::min(1.0 * vw/ih, 1.0 * vh/iw), std::min(1.0 * vw/iw, 1.0 * vh/ih));
									else
										r = std::min(std::min(1.0 * vw/ih, 1.0 * vh/iw), std::min(1.0 * vw/iw, 1.0 * vh/ih));
									if (r>1.0) r = 1.0;
									if (r>0) w_dp = ImgDblMargin / r;
								}
								//摜̌
								std::unique_ptr<Graphics::TBitmap> wbuf(new Graphics::TBitmap());
								wbuf->SetSize(
									ImgBuff->Width + i2buf->Width + w_dp, std::max(ImgBuff->Height, i2buf->Height));
								TCanvas *w_cv = wbuf->Canvas;
								w_cv->Lock();
								{
									w_cv->Brush->Color = col_bgDblPg;
									w_cv->FillRect(Rect(0, 0, wbuf->Width, wbuf->Height));
									int xp = 0, yp;
									//EԂ
									if (RightBind) {
										yp = (i_h2<i_h1)? (i_h1 - i_h2)/2 : 0;
										w_cv->Draw(xp, yp, i2buf.get());
										xp += w_dp + i2buf->Width;
										yp = (i_h1<i_h2)? (i_h2 - i_h1)/2 : 0;
										w_cv->Draw(xp, yp, ImgBuff);
									}
									//Ԃ
									else {
										yp = (i_h1<i_h2)? (i_h2 - i_h1)/2 : 0;
										w_cv->Draw(xp, yp, ImgBuff);
										xp += w_dp + ImgBuff->Width;
										yp = (i_h2<i_h1)? (i_h1 - i_h2)/2 : 0;
										w_cv->Draw(xp, yp, i2buf.get());
									}
									ImgBuff->Assign(wbuf.get());
								}
								w_cv->Unlock();
							}
							Rotation = 0;
						}
						//ʏ탂[h
						else {
							if (RotViewImg && ExifOri>0 && res!=LOADED_BY_WIC) {
								if      (ExifOri==6) Rotation = 1;
								else if (ExifOri==8) Rotation = 3;
							}
						}
						ExifOri = 0;
					}
					MsgStr = EmptyStr; Synchronize(&DrawMessage);
				}

				//\
				if (is_prv_buf)
					Synchronize(&DrawViewBuff);
				else {
					if (SameText(FileName, Img_f_name) && !ReqClear) Synchronize(&DrawImage);
					Sleep(MinShowTime);
				}

				if (SameText(FileName, Img_f_name)) FileName = FileName2 = EmptyStr;
			}
			catch (EAbort &e) {
				if (SameText(FileName, Img_f_name)) FileName = FileName2 = EmptyStr;
				Synchronize(&ClearImage);
				MsgStr = e.Message; MsgIsErr = true; Synchronize(&DrawMessage);
				Img_f_name = EmptyStr;  Img_f_size = 0;  Img_f_time = 0;  ImgIsWmf = false;
				ExifOri  = 0;
			}
			catch (...) {
				FileName = FileName2 = EmptyStr;
				Synchronize(&ClearImage);
				MsgStr = EmptyStr; Synchronize(&DrawMessage);
				Img_f_name = EmptyStr;  Img_f_size = 0;  Img_f_time = 0;  ImgIsWmf = false;
			}

			ReqVideo = false;
			TaskBusy = false;
		}
		Sleep(10);
	}

	delete ImgBuff;
	delete ViewBuff;
	delete ChgBuff;
	delete MetaBuff;

	::CoUninitialize();
}
//---------------------------------------------------------------------------
